import networkx as nx


def main():

    # edgeのリストを渡して初期化
    g = nx.Graph([(0, 1),
                  (1, 2),
                  (2, 3),
                  (10, 20),
                  (20, 30),
                  (30, 40),
                  (40, 10)])


    # nodeのリストを取得する
    print(g.nodes()) #=> [0, 1, 2, 3, 40, 10, 20, 30]


    # edgeのリストを取得する
    print(g.edges()) #=> [(0, 1), (1, 2), (2, 3),
                     #    (40, 10), (40, 30), (10, 20), (20, 30)]


    # nodeから出ている edge の数の辞書を返す
    print(g.degree()) #=> {0: 1, 1: 2, 2: 2, 3: 1,
                      #    10: 2, 20: 2, 30: 2, 40: 2}

    # Graphのインスタンスに対してnodeをインデックスアクセスすると、
    # 接続しているedgeの情報が取れる
    print(g[1]) #=> {0: {}, 2: {}}



if __name__ == '__main__':
    main()

